--{{{  LIB 
--{{{  user filer interface constants (named filestore)
--VAL file.store.is.named IS FALSE: -- unnamed filestores not supported by TDS3
VAL file.store.is.named IS TRUE: -- for named filestores
VAL fi.unnamed                   IS 1 :
VAL fi.named                     IS 0 :

--{{{  filing system interface array sizes
VAL max.files IS 4 :
VAL max.record.size IS 512 :  -- also in userhdr, uservals
VAL max.string.size IS 256 :  -- also in userhdr, uservals
VAL max.file.id.size IS 256 :
VAL max.fold.depth IS 50 :
VAL max.file.depth IS 20 :
--}}} 
--{{{  fold attribute values 27-1-88
-- Values for type
VAL ft.opstext IS 0 :
VAL ft.opsdata IS 1 :
VAL ft.opscode IS 2 :
VAL ft.foldset IS 3 :
VAL ft.voidset IS 4 :

-- Values for content
VAL fc.comment.text IS 0 :
VAL fc.source.text  IS 1 :
VAL fc.code.data    IS 2 :
VAL fc.occam1.sc    IS 3 :
VAL fc.desc.data    IS 4 :
VAL fc.debug.data   IS 5 :
VAL fc.occam1.prog  IS 6 :
VAL fc.occam1.util  IS 7 :
VAL fc.occam1.exe   IS 8 :
VAL fc.link.data    IS 9 :

VAL fc.occam2.sc    IS 10 :
VAL fc.occam2.prog  IS 11 :
VAL fc.occam2.util  IS 12 :
VAL fc.occam2.exe   IS 13 :
VAL fc.occam2.lib   IS 14 :

VAL fc.imp.proc     IS 15 :
VAL fc.imp.sc       IS 16 :
VAL fc.imp.lib      IS 17 :

VAL fc.c.proc       IS 18 :
VAL fc.c.sc         IS 19 :
VAL fc.c.lib        IS 20 :

VAL fc.pascal.proc  IS 21 :
VAL fc.pascal.sc    IS 22 :
VAL fc.pascal.lib   IS 23 :

VAL fc.fortran.proc IS 24 :
VAL fc.fortran.sc   IS 25 :
VAL fc.fortran.lib  IS 26 :

VAL fc.check.data   IS 27 :
VAL fc.image.data   IS 28 :
VAL fc.map.data     IS 29 :

VAL fc.config.info  IS 31 :
VAL fc.analyse.info IS 32 :
--}}} 
--   User filer protocol
--{{{  attribute indexes
VAL attr.size         IS 3 :
VAL attr.fold.type    IS 0 :
VAL attr.fold.content IS 1 :
VAL attr.fold.indent  IS 2 :
--}}} 
--{{{  uf. commands to user filer control
VAL uf.open.data.read    IS BYTE 1 :
VAL uf.open.data.write   IS BYTE 2 :
VAL uf.open.fold.read    IS BYTE 3 :
VAL uf.open.fold.write   IS BYTE 4 :
VAL uf.open.text.read    IS BYTE 5 :
VAL uf.open.text.write   IS BYTE 6 :

VAL uf.number.of.folds   IS BYTE 7 :
VAL uf.test.filed        IS BYTE 8 :
VAL uf.read.fold.string  IS BYTE 9 :
VAL uf.read.fold.attr    IS BYTE 10 :
VAL uf.read.file.id      IS BYTE 11 :

VAL uf.write.fold.string IS BYTE 12 :
VAL uf.make.fold.set     IS BYTE 13 :
VAL uf.unmake.fold.set   IS BYTE 14 :

VAL uf.create.fold       IS BYTE 15 :
VAL uf.delete.fold       IS BYTE 16 :
VAL uf.make.filed        IS BYTE 17 :
VAL uf.derive.file       IS BYTE 18 :
VAL uf.unfile            IS BYTE 19 :
VAL uf.delete.contents   IS BYTE 20 :
VAL uf.attach.file       IS BYTE 33 :
--}}} 
--{{{  fsd. tags from file stream and from user filer control
VAL fsd.record      IS BYTE 60 :
VAL fsd.number      IS BYTE 61 :
VAL fsd.fold        IS BYTE 62 :
VAL fsd.filed       IS BYTE 63 :
VAL fsd.endfold     IS BYTE 64 :
VAL fsd.endstream   IS BYTE 65 :
VAL fsd.attr        IS BYTE 66 :
VAL fsd.file.id     IS BYTE 67 :
VAL fsd.error       IS BYTE 68 :
VAL fsd.result      IS BYTE 69 :
VAL fsd.number.of.folds IS BYTE 70 :
VAL fsd.startstream IS BYTE 71 :
VAL fsd.endfiled    IS BYTE 72 :
--}}} 
--{{{  fsc. tags to file stream
VAL fsc.read          IS BYTE 40 :
VAL fsc.enter.fold    IS BYTE 41 :
VAL fsc.exit.fold     IS BYTE 42 :
VAL fsc.repeat.fold   IS BYTE 43 :
VAL fsc.read.attr     IS BYTE 44 :
VAL fsc.read.enc.attr IS BYTE 45 :
VAL fsc.read.file.id  IS BYTE 46 :
VAL fsc.close         IS BYTE 47 :
VAL fsc.write         IS BYTE 48 :

-- these not used by the user filer:
VAL fsc.seek          IS BYTE 49 :
VAL fsc.truncate      IS BYTE 50 :
VAL fsc.file.length   IS BYTE 51 :
--}}} 
--{{{  filer error numbers
VAL fi.ok                        IS 0 :
VAL fi.eof                       IS 1 :

--{{{  -302 to -319
VAL fi.name.too.long              IS -302 :
VAL fi.too.many.locks             IS -303 :
VAL fi.cannot.lock.write.top      IS -304 :
VAL fi.too.many.releases          IS -305 :
VAL fi.too.many.suspends          IS -306 :
VAL fi.too.many.resumes           IS -307 :
VAL fi.illegal.chrc               IS -308 :
VAL fi.cannot.change.chrc         IS -309 :
VAL fi.filer.error                IS -310 :
VAL fi.cannot.copy                IS -311 :
VAL fi.not.all.data.written       IS -312 :
VAL fi.illegal.extension          IS -313 :
VAL fi.illegal.attr               IS -314 :
VAL fi.cannot.seek                IS -315 :
VAL fi.not.all.data.read          IS -316 :
VAL fi.unknown.record.length      IS -317 :
VAL fi.illegal.record.length      IS -318 :
VAL fi.cannot.create              IS -319 :
--}}} 
--{{{  -501 to -502
VAL fi.bad.type                   IS -501 :
VAL fi.bad.content                IS -502 :
--}}} 
--{{{  -1101 to -1143
VAL fi.file.not.open             IS -1101 :
VAL fi.file.already.open         IS -1102 :
VAL fi.file.does.not.exist       IS -1103 :
VAL fi.invalid.file.number       IS -1104 :
VAL fi.invalid.operation         IS -1105 :
VAL fi.wrong.page                IS -1106 :
VAL fi.bad.page                  IS -1107 :
VAL fi.no.random.access          IS -1108 :
VAL fi.invalid.page.number       IS -1109 :
-- file not curently open, but is not flagged as closed on disk:
VAL fi.file.not.closed           IS -1110 :

-- internal errors
VAL fi.bad.max.claimed.page      IS -1111 :
VAL fi.page.out.of.range         IS -1112 :
VAL fi.file.map.error            IS -1113 :
VAL fi.device.error              IS -1120 :
VAL fi.volume.write.protected    IS -1121 :
VAL fi.volume.full               IS -1122 :
VAL fi.incorrect.volume.number   IS -1123 : -- no volume mounted on device
VAL fi.volume.must.be.dismounted IS -1124 : -- a volume is already mounted
VAL fi.volume.not.mounted        IS -1125 : -- the volume asked for not mounted
VAL fi.invalid.volume.number     IS -1126 : -- volume.number = no.volume
VAL fi.invalid.device.number     IS -1127 :
VAL fi.volume.already.mounted    IS -1128 :
VAL fi.bad.format                IS -1129 :
VAL fi.too.many.files            IS -1130 :
VAL fi.fold.too.deep             IS -1131 :
VAL fi.file.too.deep             IS -1132 :
VAL fi.unmatched.release         IS -1133 :
VAL fi.unmatched.resume          IS -1134 :
VAL fi.invalid.lock              IS -1135 :
VAL fi.invalid.chrc.number       IS -1136 :
VAL fi.invalid.command           IS -1140 :
VAL fi.filehandler.full          IS -1141 :
VAL fi.foldmanager.full          IS -1142 :
VAL fi.file.too.big              IS -1143 :
--}}} 
--{{{  -1201 to -1210
VAL fi.invalid.command           IS -1201 :
VAL fi.fold.not.empty            IS -1202 :
VAL fi.operation.failed          IS -1203 :
VAL fi.no.such.fold              IS -1204 :
VAL fi.fold.in.use               IS -1205 :
VAL fi.not.filed                 IS -1206 :
VAL fi.invalid.fold              IS -1207 :
VAL fi.failed.to.open.fold       IS -1208 :
VAL fi.file.already.exists       IS -1209 :
VAL fi.not.on.a.valid.fold       IS -1210 :
--}}} 

--}}} 

--}}} 
--}}} 
