--{{{  rtltags
--{{{  Debug fold tags
VAL rtl.startfold IS 0 :
VAL rtl.endfold   IS 1 :
VAL rtl.nextitem  IS 2 :
VAL rtl.workspace IS 3 :
VAL rtl.endseg    IS 4 :
VAL rtl.variable  IS 5 :
VAL rtl.begscope  IS 6 :
VAL rtl.endscope  IS 7 :
VAL rtl.procparam IS 8 :
VAL rtl.procedure IS 9 :
VAL rtl.constant  IS 10 :
VAL rtl.filename  IS 11 :
VAL rtl.libpatch  IS 12 :
VAL rtl.version   IS 13 :
VAL rtl.codemark  IS 14 :
VAL rtl.addressfix  IS 15 :
VAL rtl.newlibpatch IS 16 :
VAL rtl.linemark    IS 17 :
VAL rtl.profilenextitem IS 18 :  -- for the profiler only
VAL rtl.profilemark     IS 19 :
VAL rtl.nobreakmark     IS 20 :
VAL rtl.nobreaknextitem IS 21 :
VAL rtl.typedef         IS 22 :
VAL rtl.objlength       IS 23 :
VAL rtl.enummember      IS 24 :  -- an member of an enumerated type
VAL rtl.recordmember    IS 25 :  -- an member of a record (struct)
VAL rtl.variantmember   IS 26 :  -- an member of a variant record (union)
--}}}  
-- tokens to indicate the type of a variable ( these are independent
-- of the compiler's tokens, although initially they have the same values )
--{{{  Scalar types
-- tokens to indicate the type of a variable ( these are independent
-- of the compiler's tokens, although initially they have the same values )
VAL rtl.channel  IS 0 :
VAL rtl.timer    IS 1 :
VAL rtl.boolean  IS 2 :
VAL rtl.byte     IS 3 :
VAL rtl.integer  IS 4 :
VAL rtl.int16    IS 5 :
VAL rtl.int32    IS 6 :
VAL rtl.int64    IS 7 :
VAL rtl.real32   IS 8 :
VAL rtl.real64   IS 9 :
VAL rtl.protocol IS 10 :
VAL rtl.casetag  IS 11 :
VAL rtl.port     IS 12 :

VAL rtl.chanpointer IS 13 :
VAL rtl.void        IS 14 :
VAL rtl.int8        IS 15 :
VAL rtl.bit16       IS 16 :
VAL rtl.bit32       IS 17 :
VAL rtl.bit64       IS 18 :
VAL rtl.uint        IS 19 :
VAL rtl.funcpointer IS 20 :

VAL rtl.datatypes   IS 21 :

VAL rtl.minusertype IS 50 :
--}}}  
--{{{  Scalar type datasizes
-- Sizes of primitive datatypes.
-- Any negative value means "bytes per word"

VAL [rtl.datatypes]INT rtl.datasizes IS
-- CHAN, TIMER, BOOL, BYTE, INT, INT16, INT32, INT64, REAL32, REAL64,
[    -1,     0,    1,    1,  -1,     2,     4,     8,      4,      8,
-- PROTOCOL, tag, PORT, CHANPTR, VOID, INT8, BIT16, BIT32, BIT64, UINT,
0          ,   0,    0,      -1,    0,    1,     2,     4,     8,   -1,
-- FUNCPTR
-1        ] :

VAL rtl.max.datasize IS 8 :
--}}}  
--{{{  Type constructor tags
VAL rtl.array     IS 30 :
VAL rtl.pointer   IS 31 :
VAL rtl.enum      IS 32 :
VAL rtl.record    IS 33 :
VAL rtl.variant   IS 34 :
VAL rtl.alias     IS 35 :
VAL rtl.qualifier IS 36 :
VAL rtl.undef     IS 37 :
--}}}  
--{{{  procedure / function flags
VAL rtl.procflag        IS 0 :
VAL rtl.functionflag    IS 1 :
VAL rtl.scprocflag      IS 2 :
VAL rtl.scfunctionflag  IS 3 :
VAL rtl.libprocflag     IS 4 :
VAL rtl.libfunctionflag IS 5 :
--}}}  

-- Dimensions for arrays are stored in array record as type (const, var)
--{{{  array dimension info
VAL rtl.dim.type IS 0 :
VAL rtl.dim.size IS 1 :
--}}}  

-- Access modes for variables, constants, and parameters
--{{{  Access modes
-- Access modes for variables, constants, and parameters
VAL rtl.label      IS  0 :    -- means label address follows in debug info
VAL rtl.const      IS  1 :    -- means value follows in debug info
VAL rtl.byval      IS  2 :    -- means value found in offset that follows
VAL rtl.byref      IS  3 :    -- means that the offset following contains a
			      -- pointer to the value reqd
VAL rtl.placed     IS  4 :    -- means var is placed
VAL rtl.voidaccess IS  5 :    -- means NO access
VAL rtl.lsb.byval  IS  6 :    -- local static base - by value
VAL rtl.lsb.byref  IS  7 :    -- local static base - by reference
VAL rtl.gsb.byval  IS  8 :    -- global static base - by value
VAL rtl.gsb.byref  IS  9 :    -- global static base - by reference
--}}}  

-- tags to indicate which type of segment is being entered
-- tags for workspace ( eg produced by runtime.workspace )
--{{{  segment info
VAL rtltag.proc   IS #10000000 :
VAL rtltag.par    IS #20000000 :
VAL rtltag.repl   IS #30000000 :
VAL rtltag.kern   IS #40000000 :
VAL rtltag.main   IS #50000000 :
VAL rtltag.run    IS #60000000 :
VAL rtltag.pripar IS #70000000 :
VAL rtltag.seq    IS #80000000 :

VAL rtltag.shift IS 28 : -- the no of shifts to get the above to 1,2,3,...

VAL tag.mask     IS #7F000000 :
VAL addr.mask    IS #00FFFFFF :
--}}}  
--{{{  binder output format
-- the binder currently outputs the following records for
-- aiding runtime locate.

     -- ( tag.startfold \/ index )
     -- ( tag.endfold \/ index )
     -- ( tag.nextitem \/ index )
     -- ( tag.endseg \/ index )
     -- ( tag.begscope \/ index )
     -- ( tag.endscope \/ index )
     -- ( tag.workspace \/ index ) ( segment.type \/ offset )       ( level )
     -- ( tag.variable \/ index )  ( variable type ) ( variable access ) ...
     --       ( no. of dimens ) { ( dimen access ) ( dimen size ) } ...
     --                                ( variable id ) ( offset )
     -- ( tag.procparam \/ index ) ( variable type ) ( variable size ) ...
     --                                ( param id ) ( offset )
     -- ( tag.procedure \/ index ) ( procedure id )
     -- ( tag.constant \/ index )  ( type ) ( const id ) ( higher 32 bits )
     --                            ( lower 32 bits )

--}}}  
--{{{  binder tags
VAL tag.nextitem  IS #01000000 :
VAL tag.startfold IS #02000000 :
VAL tag.endfold   IS #03000000 :
VAL tag.endseg    IS #04000000 :
VAL tag.begscope  IS #05000000 :
VAL tag.endscope  IS #06000000 :
VAL tag.workspace IS #07000000 :
VAL tag.variable  IS #08000000 :
VAL tag.procedure IS #0A000000 :
VAL tag.constant  IS #0B000000 :
VAL tag.label     IS #0C000000 :  -- used in same manner as m.name in binder
				  -- only to indicate next thing is label
VAL tag.libpatch  IS #0D000000 :
VAL tag.profilenextitem IS #0E000000 :

VAL highest.index IS #00FFFFFF :
--}}}  
--{{{  constants
VAL tag.startofrtltags    IS tag.nextitem :
VAL tag.endoffoldrecs     IS tag.endfold \/ highest.index :
VAL tag.startofsinglerecs IS tag.startfold :
VAL tag.endofsinglerecs   IS tag.endscope \/ highest.index :
VAL tag.endofrtltags      IS highest.index \/ tag.profilenextitem :
			     -- marker for end of rtl tags, used in debug
--}}}  
--{{{  record sizes
VAL rtl.foldtype.size   IS 1 :
VAL rtl.workspace.size  IS 3 :  -- size of workspace record
VAL rtl.variable.size   IS 3 :  -- size of variable record
VAL rtl.parameter.size  IS 3 :  -- size of parameter record
VAL rtl.procedure.size  IS 5 :  -- size of procedure name record
VAL rtl.constant.size   IS 5 :  -- size of constant record
--}}}  
--{{{  error codes
VAL runtime.read.error1 IS 77 :
VAL runtime.read.error2 IS 78 :
VAL runtime.overall.read.error IS 79 :
VAL bind.runtime.write  IS 80 :
--}}}  
--{{{  debug fold tags
VAL rtl.startfold   IS 0 :
VAL rtl.endfold     IS 1 :
VAL rtl.nextitem    IS 2 :
VAL rtl.workspace   IS 3 :
VAL rtl.endseg      IS 4 :
VAL rtl.variable    IS 5 :
VAL rtl.begscope    IS 6 :
VAL rtl.endscope    IS 7 :
VAL rtl.procparam   IS 8 :
VAL rtl.procedure   IS 9 :
VAL rtl.constant    IS 10 :
VAL rtl.filename    IS 11 :
VAL rtl.libpatch    IS 12 :
VAL rtl.version     IS 13 :  --these from toolset
VAL rtl.codemark    IS 14 :
VAL rtl.addressfix  IS 15 :
VAL rtl.newlibpatch IS 16 :
VAL rtl.linemark    IS 17 :
VAL rtl.profilenextitem IS 18 :
--}}}  
--}}}  
